Index: /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3d_common/infotrac.F90	(revision 4050)
@@ -32,17 +32,8 @@
   TYPE(isot_type), TARGET,  SAVE, ALLOCATABLE :: isotopes(:)    !=== ISOTOPES PARAMETERS VECTOR
 
-! iadv  : index of trasport schema for each tracer
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: iadv
-
 ! niadv : vector keeping the coorspondance between all tracers(nqtot) treated in the 
 !         dynamic part of the code and the tracers (nbtr+2) used in the physics part of the code. 
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: niadv ! equivalent dyn / physique
 
-! CRisi: tableaux de fils
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: nqfils
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: nqdesc ! nombres de fils + nombre de tous les petits fils sur toutes les generations
-  INTEGER, SAVE :: nqdesc_tot
-  INTEGER, ALLOCATABLE, DIMENSION(:,:), SAVE    :: iqfils
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: iqpere
   REAL :: qperemin,masseqmin,ratiomin ! MVals et CRisi
   PARAMETER (qperemin=1e-30,masseqmin=1e-18,ratiomin=1e-16) ! MVals
@@ -63,8 +54,5 @@
   LOGICAL, DIMENSION(niso_possibles),SAVE ::  use_iso
   INTEGER, ALLOCATABLE, DIMENSION(:,:), SAVE ::  iqiso ! donne indice iq en fn de (ixt,phase) 
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE ::  iso_num ! donne numero iso entre 1 et niso_possibles en fn de nqtot
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE ::  iso_indnum ! donne numero iso entre 1 et niso effectif en fn de nqtot
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE ::  zone_num ! donne numero de la zone de tracage en fn de nqtot
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE ::  phase_num ! donne numero de la zone de tracage en fn de nqtot
   INTEGER, DIMENSION(niso_possibles), SAVE :: indnum_fn_num ! donne indice entre entre 1 et niso en fonction du numero d isotope entre 1 et niso_possibles
   INTEGER, ALLOCATABLE, DIMENSION(:,:), SAVE ::  index_trac ! numero ixt en fn izone, indnum entre 1 et niso
@@ -128,9 +116,10 @@
   
     INTEGER :: nqtrue  ! number of tracers read from tracer.def, without higer order of moment
-    INTEGER :: iq, new_iq, iiq, jq, ierr,itr
-    INTEGER :: ifils,ipere,generation ! CRisi
+    INTEGER :: iq, new_iq, iiq, jq, ierr,itr, iadv
+    INTEGER :: ifils,ipere ! CRisi
     LOGICAL :: continu,nouveau_traceurdef
     INTEGER :: IOstatus ! gestion de la retrocompatibilite de traceur.def
     CHARACTER(len=maxlen) :: tchaine    
+    INTEGER, ALLOCATABLE  :: iqfils(:,:)
 
     character(len=*),parameter :: modname="infotrac_init"
@@ -565,5 +554,5 @@
 !
     ALLOCATE(tracers(nqtot))
-    ALLOCATE(iadv(nqtot), niadv(nqtot))
+    ALLOCATE(niadv(nqtot))
 
 !-----------------------------------------------------------------------
@@ -578,7 +567,7 @@
        ! Verify choice of advection schema
        IF (hadv(iq)==vadv(iq)) THEN
-          iadv(new_iq)=hadv(iq)
+          tracers(new_iq)%iadv=hadv(iq)
        ELSE IF (hadv(iq)==10 .AND. vadv(iq)==16) THEN
-          iadv(new_iq)=11
+          tracers(new_iq)%iadv=11
        ELSE
           WRITE(lunout,*)trim(modname),': This choice of advection schema is not available',iq,hadv(iq),vadv(iq)
@@ -588,24 +577,25 @@
       
        str1=tnom_0(iq)
-       tracers(new_iq)%name=TRIM(tnom_0(iq))
-       IF (iadv(new_iq)==0) THEN
+       tracers(new_iq)%name = TRIM(tnom_0(iq))
+       tracers(new_iq)%parent = TRIM(tnom_transp(iq))
+       IF (tracers(new_iq)%iadv==0) THEN
           tracers(new_iq)%longName=trim(str1)
        ELSE
-          tracers(new_iq)%longName=trim(tnom_0(iq))//descrq(iadv(new_iq))
+          tracers(new_iq)%longName=trim(tnom_0(iq))//descrq(tracers(new_iq)%iadv)
        ENDIF
 
        ! schemas tenant compte des moments d'ordre superieur
        str2=TRIM(tracers(new_iq)%longName)
-       IF (iadv(new_iq)==20) THEN
+       IF (tracers(new_iq)%iadv==20) THEN
           DO jq=1,3
              new_iq=new_iq+1
-             iadv(new_iq)=-20
+             tracers(new_iq)%iadv=-20
              tracers(new_iq)%longName=trim(str2)//txts(jq)
              tracers(new_iq)%name=trim(str1)//txts(jq)
           END DO
-       ELSE IF (iadv(new_iq)==30) THEN
+       ELSE IF (tracers(new_iq)%iadv==30) THEN
           DO jq=1,9
              new_iq=new_iq+1
-             iadv(new_iq)=-30
+             tracers(new_iq)%iadv=-30
              tracers(new_iq)%longName=trim(str2)//txtp(jq)
              tracers(new_iq)%name=trim(str1)//txtp(jq)
@@ -620,5 +610,5 @@
     iiq=0
     DO iq=1,nqtot
-       IF(iadv(iq).GE.0) THEN
+       IF(tracers(iq)%iadv.GE.0) THEN
           ! True tracer
           iiq=iiq+1
@@ -632,5 +622,5 @@
 
     DO iq=1,nqtot
-       WRITE(lunout,*) iadv(iq),niadv(iq), ' ',trim(tracers(iq)%name),' ',trim(tracers(iq)%longName)
+       WRITE(lunout,*) tracers(iq)%iadv,niadv(iq), ' ',trim(tracers(iq)%name),' ',trim(tracers(iq)%longName)
     END DO
 
@@ -640,9 +630,10 @@
 !
     DO iq=1,nqtot
-       IF (iadv(iq)/=10 .AND. iadv(iq)/=14 .AND. iadv(iq)/=0) THEN
-          WRITE(lunout,*)trim(modname),' STOP : The option iadv=',iadv(iq),' is not tested in this version of LMDZ'
+       iadv=tracers(iq)%iadv
+       IF (ALL([10, 14, 0]/=iadv)) THEN
+          WRITE(lunout,*)trim(modname),' STOP : The option iadv=',iadv,' is not tested in this version of LMDZ'
           CALL abort_gcm('infotrac_init','In this version only iadv=10 and iadv=14 is tested!',1)
-       ELSE IF (iadv(iq)==14 .AND. iq/=1) THEN
-          WRITE(lunout,*)trim(modname),'STOP : The option iadv=',iadv(iq),' is not tested in this version of LMDZ'
+       ELSE IF (iadv==14 .AND. iq/=1) THEN
+          WRITE(lunout,*)trim(modname),'STOP : The option iadv=',iadv,' is not tested in this version of LMDZ'
           CALL abort_gcm('infotrac_init','In this version iadv=14 is only permitted for water vapour!',1)
        ENDIF
@@ -653,13 +644,8 @@
 ! initialiser tous les tableaux d'indices lies aux traceurs familiaux
 ! + verifier que tous les peres sont ecrits en premieres positions
-    ALLOCATE(nqfils(nqtot),nqdesc(nqtot))    
     ALLOCATE(iqfils(nqtot,nqtot))   
-    ALLOCATE(iqpere(nqtot))
     nqperes=0
-    nqfils(:)=0
-    nqdesc(:)=0
     iqfils(:,:)=0
-    iqpere(:)=0
-    nqdesc_tot=0    
+    tracers(:)%iqParent=0
     DO iq=1,nqtot
       if (tnom_transp(iq) == 'air') then
@@ -667,5 +653,5 @@
         WRITE(lunout,*) 'Le traceur',iq,', appele ',trim(tnom_0(iq)),', est un pere'
         nqperes=nqperes+1
-        iqpere(iq)=0
+        tracers(iq)%iqParent=0
       else !if (tnom_transp(iq) == 'air') then
         ! ceci est un fils. Qui est son pere?
@@ -681,7 +667,7 @@
                 CALL abort_gcm('infotrac_init','Un fils est son propre pere',1)
             endif
-            nqfils(ipere)=nqfils(ipere)+1  
-            iqfils(nqfils(ipere),ipere)=iq
-            iqpere(iq)=ipere         
+            tracers(ipere)%nqChilds = tracers(ipere)%nqChilds+1  
+            iqfils(tracers(ipere)%nqChilds,ipere)=iq
+            tracers(iq)%iqParent=ipere         
             continu=.false.
           else !if (tnom_transp(iq) == tnom_0(ipere)) then
@@ -697,49 +683,55 @@
     enddo !DO iq=1,nqtot
     WRITE(lunout,*) 'infotrac: nqperes=',nqperes    
-    WRITE(lunout,*) 'nqfils=',nqfils
-    WRITE(lunout,*) 'iqpere=',iqpere
+    WRITE(lunout,*) 'nqChilds=',tracers(:)%nqChilds
+    WRITE(lunout,*) 'iqParent=',tracers(:)%iqParent
     WRITE(lunout,*) 'iqfils=',iqfils
 
 ! Calculer le nombre de descendants a partir de iqfils et de nbfils
     DO iq=1,nqtot    
-      generation=0
+      tracers(iq)%iGeneration=0
       continu=.true.
       ifils=iq
       do while (continu)
-        ipere=iqpere(ifils)
+        ipere=tracers(ifils)%iqParent
         if (ipere.gt.0) then
-         nqdesc(ipere)=nqdesc(ipere)+1   
-         nqdesc_tot=nqdesc_tot+1      
-         iqfils(nqdesc(ipere),ipere)=iq
+         tracers(ipere)%nqDescen = tracers(ipere)%nqDescen+1   
+         iqfils(tracers(ipere)%nqDescen,ipere)=iq
          ifils=ipere
-         generation=generation+1
+         tracers(iq)%iGeneration=tracers(iq)%iGeneration+1
         else !if (ipere.gt.0) then
          continu=.false.
         endif !if (ipere.gt.0) then
       enddo !do while (continu)    
-      WRITE(lunout,*) 'Le traceur ',iq,', appele ',trim(tnom_0(iq)),' est un traceur de generation: ',generation
+      WRITE(lunout,*) 'Le traceur ',iq,', appele ',trim(tnom_0(iq)), &
+        ' est un traceur de generation: ',tracers(iq)%iGeneration
     enddo !DO iq=1,nqtot
-    WRITE(lunout,*) 'infotrac: nqdesc=',nqdesc
+    DO iq=1,nqtot
+      ALLOCATE(tracers(iq)%iqDescen(tracers(iq)%nqDescen))
+      tracers(iq)%iqDescen(:) = iqfils(1:tracers(iq)%nqDescen,iq)
+    END DO
+
+    WRITE(lunout,*) 'infotrac: nqDescen=',tracers(iq)%nqDescen
     WRITE(lunout,*) 'iqfils=',iqfils
-    WRITE(lunout,*) 'nqdesc_tot=',nqdesc_tot
+    WRITE(lunout,*) 'nqDescen_tot=',SUM(tracers(:)%nqDescen)
 
 ! Interdire autres schemas que 10 pour les traceurs fils, et autres schemas
 ! que 10 et 14 si des peres ont des fils
     do iq=1,nqtot
-      if (iqpere(iq).gt.0) then
+      if (tracers(iq)%iqParent > 0) then
         ! ce traceur a un pere qui n'est pas l'air
         ! Seul le schema 10 est autorise
-        if (iadv(iq)/=10) then
-           WRITE(lunout,*)trim(modname),' STOP : The option iadv=',iadv(iq),' is not implemented for sons'
+        iadv=tracers(iq)%iadv
+        if (iadv/=10) then
+           WRITE(lunout,*)trim(modname),' STOP : The option iadv=',iadv,' is not implemented for sons'
           CALL abort_gcm('infotrac_init','Sons should be advected by scheme 10',1)
         endif
         ! Le traceur pere ne peut etre advecte que par schema 10 ou 14:
-        IF (iadv(iqpere(iq))/=10 .AND. iadv(iqpere(iq))/=14) THEN
-          WRITE(lunout,*)trim(modname),' STOP : The option iadv=',iadv(iq),' is not implemented for fathers'
+        IF (ALL([10,14]/=tracers(tracers(iq)%iqParent)%iadv)) THEN
+          WRITE(lunout,*)trim(modname),' STOP : The option iadv=',iadv,' is not implemented for fathers'
           CALL abort_gcm('infotrac_init','Fathers should be advected by scheme 10 ou 14',1)
-        endif !IF (iadv(iqpere(iq))/=10 .AND. iadv(iqpere(iq))/=14) THEN
-     endif !if (iqpere(iq).gt.0) the
+        endif
+     endif
     enddo !do iq=1,nqtot
-
+    tracers(:)%gen0Name = ancestor(tracers)      !--- Name of the first generation ancestor
 
 
@@ -763,9 +755,9 @@
         itr=0
         do iq=nqo+1, nqtot
-          if (iso_num(iq).eq.0) then
+          if (tracers(iq)%iso_iName.eq.0) then
             itr=itr+1
             write(*,*) 'itr=',itr
             itr_indice(itr)=iq
-          endif !if (iso_num(iq).eq.0) then
+          endif !if (tracers(iq)%iso_iName.eq.0) then
         enddo
         if (itr.ne.nqtottr) then
@@ -811,13 +803,7 @@
     ALLOCATE(nb_isoind(nqo))
     ALLOCATE(nb_traciso(niso_possibles,nqo))
-    ALLOCATE(iso_num(nqtot))
     ALLOCATE(iso_indnum(nqtot))
-    ALLOCATE(zone_num(nqtot))
-    ALLOCATE(phase_num(nqtot))
      
-    iso_num(:)=0
     iso_indnum(:)=0
-    zone_num(:)=0
-    phase_num(:)=0
     indnum_fn_num(:)=0
     use_iso(:)=.false.  
@@ -841,27 +827,20 @@
           nb_iso(ixt,phase)=nb_iso(ixt,phase)+1   
           nb_isoind(phase)=nb_isoind(phase)+1   
-          iso_num(iq)=ixt
+          tracers(iq)%iso_iName=ixt
           iso_indnum(iq)=nb_isoind(phase)
           indnum_fn_num(ixt)=iso_indnum(iq)
-          phase_num(iq)=phase
-!          write(lunout,*) 'iso_num(iq)=',iso_num(iq)
-!          write(lunout,*) 'iso_indnum(iq)=',iso_indnum(iq)
-!          write(lunout,*) 'indnum_fn_num(ixt)=',indnum_fn_num(ixt)
-!          write(lunout,*) 'phase_num(iq)=',phase_num(iq)
+          tracers(iq)%iso_iPhase=phase
           goto 20
-         else if (iqpere(iq).gt.0) then          
-          if (tnom_0(iqpere(iq)) == tnom_trac) then
+         else if ( tracers(iq)%iqParent> 0) then          
+          if (tnom_0(tracers(iq)%iqParent) == tnom_trac) then
 !           write(lunout,*) 'Ce traceur est le fils d''un isotope'
            ! c'est un traceur d'isotope
            nb_traciso(ixt,phase)=nb_traciso(ixt,phase)+1
-           iso_num(iq)=ixt
+           tracers(iq)%iso_iName=ixt
            iso_indnum(iq)=indnum_fn_num(ixt)
-           zone_num(iq)=nb_traciso(ixt,phase)
-           phase_num(iq)=phase
-!           write(lunout,*) 'iso_num(iq)=',iso_num(iq)
-!           write(lunout,*) 'phase_num(iq)=',phase_num(iq)
-!           write(lunout,*) 'zone_num(iq)=',zone_num(iq)
+           tracers(iq)%iso_iZone=nb_traciso(ixt,phase)
+           tracers(iq)%iso_iPhase=phase
            goto 20
-          endif !if (tnom_0(iqpere(iq)) == trim(tnom_0(phase))//trim(tnom_iso(ixt))) then
+          endif !if (tnom_0(tracers(iq)%iqParent) == trim(tnom_0(phase))//trim(tnom_iso(ixt))) then
          endif !IF (tnom_0(iq) == trim(tnom_0(phase))//trim(tnom_iso(ixt))) then
         enddo !do ixt= niso_possibles
@@ -869,10 +848,4 @@
   20   continue
       enddo !do iq=1,nqtot
-
-!      write(lunout,*) 'iso_num=',iso_num
-!      write(lunout,*) 'iso_indnum=',iso_indnum
-!      write(lunout,*) 'zone_num=',zone_num  
-!      write(lunout,*) 'phase_num=',phase_num
-!      write(lunout,*) 'indnum_fn_num=',indnum_fn_num
 
       do ixt= 1,niso_possibles  
@@ -926,9 +899,5 @@
  
     ! flags isotopiques:
-    if (niso.gt.0) then
-        ok_isotopes=.true.
-    else
-        ok_isotopes=.false.
-    endif 
+    ok_isotopes = niso > 0
 !    WRITE(lunout,*) 'ok_isotopes=',ok_isotopes
  
@@ -955,7 +924,7 @@
     iqiso(:,:)=0     
     do iq=1,nqtot
-        if (iso_num(iq).gt.0) then
-          ixt=iso_indnum(iq)+zone_num(iq)*niso
-          iqiso(ixt,phase_num(iq))=iq
+        if (tracers(iq)%iso_iName > 0) then
+          ixt=iso_indnum(iq)+tracers(iq)%iso_iZone*niso
+          iqiso(ixt,tracers(iq)%iso_iPhase)=iq
         endif
     enddo
Index: /LMDZ6/trunk/libf/dyn3d_common/iso_verif_dyn.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3d_common/iso_verif_dyn.F	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3d_common/iso_verif_dyn.F	(revision 4050)
@@ -64,5 +64,5 @@
         function iso_verif_aberrant_nostop
      :           (x,iso,q,err_msg)
-        USE infotrac
+        USE infotrac, ONLY: tnat
         implicit none
         
Index: /LMDZ6/trunk/libf/dyn3dmem/advtrac_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/advtrac_loc.F	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/advtrac_loc.F	(revision 4050)
@@ -24,5 +24,5 @@
       USE Vampir
       USE times
-      USE infotrac, ONLY: nqtot, iadv, ok_iso_verif
+      USE infotrac, ONLY: nqtot, tracers, ok_iso_verif
       USE control_mod, ONLY: iapp_tracvl, day_step, planet_type
       USE advtrac_mod, ONLY: finmasse
@@ -74,5 +74,5 @@
       DATA fill/.true./
       DATA dum/.true./
-      integer ijb,ije,ijbu,ijbv,ijeu,ijev,j
+      integer ijb,ije,ijbu,ijbv,ijeu,ijev,j, iadv
       type(Request),SAVE :: testRequest
 !$OMP THREADPRIVATE(testRequest)
@@ -152,6 +152,5 @@
                  
           !write(*,*) 'advtrac 157: appel de vlspltgen_loc'
-          call vlspltgen_loc( q,iadv, 2., massem, wg ,
-     *                        pbarug,pbarvg,dtvr,p,
+          call vlspltgen_loc( q, 2., massem, wg,pbarug,pbarvg,dtvr,p,
      *                        pk,teta )
 
@@ -169,28 +168,30 @@
       do iq=1,nqtot
 c        call clock(t_initial)
-        if(iadv(iq) == 0) cycle 
+        iadv = tracers(iq)%iadv
+        SELECT CASE(iadv)
+          CASE(0); CYCLE
+          CASE(10)
 c   ----------------------------------------------------------------
 c   Schema de Van Leer I MUSCL
 c   ----------------------------------------------------------------
-        if(iadv(iq).eq.10) THEN
      
 !LF            call vlsplt_p(q(1,1,iq),2.,massem,wg,pbarug,pbarvg,dtvr)
 
+          CASE(14)
 c   ----------------------------------------------------------------
 c   Schema "pseudo amont" + test sur humidite specifique
 C    pour la vapeur d'eau. F. Codron
 c   ----------------------------------------------------------------
-        else if(iadv(iq).eq.14) then
 c
 cym           stop 'advtrac : appel à vlspltqs :schema non parallelise'
 !LF           CALL vlspltqs_p( q(1,1,1), 2., massem, wg ,
 !LF     *                 pbarug,pbarvg,dtvr,p,pk,teta )
+          CASE(12)
 c   ----------------------------------------------------------------
 c   Schema de Frederic Hourdin
 c   ----------------------------------------------------------------
-        else if(iadv(iq).eq.12) then
           stop 'advtrac : schema non parallelise'
 c            Pas de temps adaptatif
-           call adaptdt(iadv(iq),dtbon,n,pbarug,massem)
+           call adaptdt(iadv,dtbon,n,pbarug,massem)
            if (n.GT.1) then
            write(*,*) 'WARNING horizontal dt=',dtbon,'dtvr=',
@@ -200,8 +201,8 @@
             call advn(q(1,1,iq),massem,wg,pbarug,pbarvg,dtbon,1)
            end do
-        else if(iadv(iq).eq.13) then
+          CASE(13)
           stop 'advtrac : schema non parallelise'
 c            Pas de temps adaptatif
-           call adaptdt(iadv(iq),dtbon,n,pbarug,massem)
+           call adaptdt(iadv,dtbon,n,pbarug,massem)
            if (n.GT.1) then
            write(*,*) 'WARNING horizontal dt=',dtbon,'dtvr=',
@@ -211,19 +212,19 @@
             call advn(q(1,1,iq),massem,wg,pbarug,pbarvg,dtbon,2)
           end do
+          CASE(20)
 c   ----------------------------------------------------------------
 c   Schema de pente SLOPES
 c   ----------------------------------------------------------------
-        else if (iadv(iq).eq.20) then
           stop 'advtrac : schema non parallelise'
 
             call pentes_ini (q(1,1,iq),wg,massem,pbarug,pbarvg,0)
 
+          CASE(30)
 c   ----------------------------------------------------------------
 c   Schema de Prather
 c   ----------------------------------------------------------------
-        else if (iadv(iq).eq.30) then
           stop 'advtrac : schema non parallelise'
 c            Pas de temps adaptatif
-           call adaptdt(iadv(iq),dtbon,n,pbarug,massem)
+           call adaptdt(iadv,dtbon,n,pbarug,massem)
            if (n.GT.1) then
            write(*,*) 'WARNING horizontal dt=',dtbon,'dtvr=',
@@ -232,9 +233,8 @@
            call  prather(q(1,1,iq),wg,massem,pbarug,pbarvg,
      s                     n,dtbon)
+          CASE(11,16,17,18)
 c   ----------------------------------------------------------------
 c   Schemas PPM Lin et Rood
 c   ----------------------------------------------------------------
-       else if (iadv(iq).eq.11.OR.(iadv(iq).GE.16.AND.
-     s                     iadv(iq).LE.18)) then
 
            stop 'advtrac : schema non parallelise'
@@ -242,5 +242,5 @@
 c        Test sur le flux horizontal
 c        Pas de temps adaptatif
-         call adaptdt(iadv(iq),dtbon,n,pbarug,massem)
+         call adaptdt(iadv,dtbon,n,pbarug,massem)
          if (n.GT.1) then
            write(*,*) 'WARNING horizontal dt=',dtbon,'dtvr=',
@@ -273,5 +273,6 @@
 c                         VL (version PPM) horiz. et PPM vert.
 c---------------------------------------------------------------------
-                if (iadv(iq).eq.11) then
+            SELECT CASE(iadv)
+              CASE(11)
 c                  Ss-prg PPM3d de Lin
                   call ppm3d(1,qppm(1,1,iq),
@@ -281,8 +282,8 @@
      s                       fill,dum,220.)
 
+              CASE(16)
 c----------------------------------------------------------------------
 c                           Monotonic PPM
 c----------------------------------------------------------------------
-               else if (iadv(iq).eq.16) then
 c                  Ss-prg PPM3d de Lin
                   call ppm3d(1,qppm(1,1,iq),
@@ -293,8 +294,8 @@
 c---------------------------------------------------------------------
 
+              CASE(17)
 c---------------------------------------------------------------------
 c                           Semi Monotonic PPM
 c---------------------------------------------------------------------
-               else if (iadv(iq).eq.17) then
 c                  Ss-prg PPM3d de Lin
                   call ppm3d(1,qppm(1,1,iq),
@@ -305,8 +306,8 @@
 c---------------------------------------------------------------------
 
+              CASE(18)
 c---------------------------------------------------------------------
 c                         Positive Definite PPM
 c---------------------------------------------------------------------
-                else if (iadv(iq).eq.18) then
 c                  Ss-prg PPM3d de Lin
                   call ppm3d(1,qppm(1,1,iq),
@@ -316,5 +317,5 @@
      s                       fill,dum,220.)
 c---------------------------------------------------------------------
-                endif
+            END SELECT
             enddo
 c-----------------------------------------------------------------
@@ -322,5 +323,5 @@
 c-----------------------------------------------------------------
                   call interpost(q(1,1,iq),qppm(1,1,iq))
-            endif
+        END SELECT
 c----------------------------------------------------------------------
 
Index: /LMDZ6/trunk/libf/dyn3dmem/advtrac_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/advtrac_mod.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/advtrac_mod.F90	(revision 4050)
@@ -9,5 +9,4 @@
   USE allocate_field_mod
   USE parallel_lmdz
-  USE infotrac
   USE vlspltgen_mod
   IMPLICIT NONE
Index: /LMDZ6/trunk/libf/dyn3dmem/caladvtrac_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/caladvtrac_mod.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/caladvtrac_mod.F90	(revision 4050)
@@ -23,5 +23,5 @@
   USE allocate_field_mod
   USE parallel_lmdz
-  USE infotrac
+  USE infotrac, ONLY: nqtot
   USE advtrac_mod, ONLY : advtrac_allocate
   USE groupe_mod 
Index: /LMDZ6/trunk/libf/dyn3dmem/call_calfis_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/call_calfis_mod.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/call_calfis_mod.F90	(revision 4050)
@@ -37,5 +37,5 @@
   USE parallel_lmdz
   USE dimensions_mod
-  USE infotrac
+  USE infotrac, ONLY: nqtot
   IMPLICIT NONE
     TYPE(distrib),POINTER :: d
@@ -80,5 +80,5 @@
   USE Bands
   USE vampir
-  USE infotrac
+  USE infotrac, ONLY: nqtot
   USE control_mod
   USE write_field_loc
Index: /LMDZ6/trunk/libf/dyn3dmem/check_isotopes_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/check_isotopes_loc.F	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/check_isotopes_loc.F	(revision 4050)
@@ -1,4 +1,6 @@
         subroutine check_isotopes(q,ijb,ije,err_msg)
-        USE infotrac
+        USE infotrac, ONLY: nqtot, nqo, niso, ntraciso, ntraceurs_zone, 
+     &                ok_isotopes, ok_isotrac, use_iso, 
+     &                iqiso, indnum_fn_num, index_trac, tnat
         USE parallel_lmdz
         implicit none
Index: /LMDZ6/trunk/libf/dyn3dmem/dynetat0_loc.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/dynetat0_loc.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/dynetat0_loc.F90	(revision 4050)
@@ -7,9 +7,8 @@
 !-------------------------------------------------------------------------------
   USE parallel_lmdz
-  USE infotrac
+  USE infotrac,    ONLY: nqtot, tracers, iqiso, iso_indnum, tnat, alpha_ideal, ok_isotopes, maxlen
   USE netcdf, ONLY: NF90_OPEN,  NF90_INQUIRE_DIMENSION, NF90_INQ_VARID,        &
       NF90_NOWRITE, NF90_CLOSE, NF90_INQUIRE_VARIABLE,  NF90_GET_VAR, NF90_NoErr
   USE control_mod, ONLY: planet_type
-  USE strings_mod, ONLY: maxlen
   USE assert_eq_m, ONLY: assert_eq
   USE comvert_mod, ONLY: pa,preff
@@ -42,5 +41,5 @@
   CHARACTER(LEN=maxlen) :: msg, var, modname
   INTEGER, PARAMETER :: length=100
-  INTEGER :: iq, fID, vID, idecal, ierr
+  INTEGER :: iq, fID, vID, idecal, ierr, iqParent, iName, iZone, iPhase
   REAL    :: time, tab_cntrl(length)               !--- RUN PARAMS TABLE
   REAL,             ALLOCATABLE :: vcov_glo(:,:),masse_glo(:,:),   ps_glo(:)
@@ -174,8 +173,12 @@
    !--- CRisi: for isotops, theoretical initialization using very simplified
    !           Rayleigh distillation las.
-    IF(ok_isotopes.AND.iso_num(iq)>0) THEN
-      IF(zone_num(iq)==0) q(:,:,iq)=q(:,:,iqpere(iq))*tnat(iso_num(iq))        &
-     &           *(q(:,:,iqpere(iq))/30.e-3)**(alpha_ideal(iso_num(iq))-1)
-      IF(zone_num(iq)==1) q(:,:,iq)=q(:,:,iqiso(iso_indnum(iq),phase_num(iq)))
+    iName = tracers(iq)%iso_iName
+    iZone = tracers(iq)%iso_iZone
+    iPhase= tracers(iq)%iso_iPhase
+    iqParent = tracers(iq)%iqParent
+    IF(ok_isotopes .AND. iName>0) THEN
+      IF(iZone==0) q(:,:,iq) = q(:,:,iqParent)*tnat(iName)    &
+     &           *(q(:,:,iqParent)/30.e-3)**(alpha_ideal(iName)-1.)
+      IF(iZone==1) q(:,:,iq) = q(:,:,iqiso(iso_indnum(iq),iPhase))
     END IF
   END DO
Index: /LMDZ6/trunk/libf/dyn3dmem/dynredem_loc.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/dynredem_loc.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/dynredem_loc.F90	(revision 4050)
@@ -9,10 +9,9 @@
   USE parallel_lmdz
   USE mod_hallo
-  USE infotrac
+  USE infotrac, ONLY: nqtot, tracers, maxlen
   USE netcdf, ONLY: NF90_CREATE, NF90_DEF_DIM, NF90_INQ_VARID, NF90_GLOBAL,    &
                     NF90_CLOSE,  NF90_PUT_ATT, NF90_UNLIMITED, NF90_CLOBBER,   &
                     NF90_64BIT_OFFSET
   USE dynredem_mod, ONLY: cre_var, put_var, err, modname, fil
-  USE strings_mod, ONLY: maxlen
   USE comvert_mod, ONLY: ap,bp,aps,bps,presnivs,pseudoalt,pa,preff, &
                          nivsig,nivsigs
@@ -175,5 +174,5 @@
   USE parallel_lmdz
   USE mod_hallo
-  USE infotrac
+  USE infotrac, ONLY: nqtot, tracers, type_trac, maxlen
   USE control_mod
   USE netcdf,   ONLY: NF90_OPEN,  NF90_NOWRITE, NF90_GET_VAR, NF90_INQ_VARID,  &
Index: /LMDZ6/trunk/libf/dyn3dmem/gcm.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/gcm.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/gcm.F90	(revision 4050)
@@ -9,5 +9,5 @@
   USE mod_const_mpi, ONLY: init_const_mpi
   USE parallel_lmdz
-  USE infotrac
+  USE infotrac, ONLY: nqtot, infotrac_init
 !#ifdef CPP_PHYS
 !  USE mod_interface_dyn_phys, ONLY: init_interface_dyn_phys
Index: /LMDZ6/trunk/libf/dyn3dmem/groupe_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/groupe_mod.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/groupe_mod.F90	(revision 4050)
@@ -10,5 +10,5 @@
   USE allocate_field_mod
   USE parallel_lmdz
-  USE infotrac
+!  USE infotrac
   USE advtrac_mod, ONLY : advtrac_allocate 
   IMPLICIT NONE
Index: /LMDZ6/trunk/libf/dyn3dmem/iniacademic_loc.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/iniacademic_loc.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/iniacademic_loc.F90	(revision 4050)
@@ -7,6 +7,6 @@
   use exner_hyb_m, only: exner_hyb
   use exner_milieu_m, only: exner_milieu
-  USE infotrac, ONLY: nqtot,niso_possibles,ok_isotopes,iqpere,ok_iso_verif,tnat,alpha_ideal, &
-        & iqiso,phase_num,iso_indnum,iso_num,zone_num
+  USE infotrac, ONLY: nqtot, niso_possibles, ok_isotopes, ok_iso_verif, tnat, alpha_ideal, &
+                      iqiso, tracers, iso_indnum
   USE control_mod, ONLY: day_step,planet_type
   USE parallel_lmdz, ONLY: ijb_u, ije_u, ijb_v, ije_v
@@ -67,5 +67,5 @@
   real tetastrat ! potential temperature in the stratosphere, in K
   real tetajl(jjp1,llm)
-  INTEGER i,j,l,lsup,ij
+  INTEGER i,j,l,lsup,ij, iq, iName, iZone, iPhase, iqParent
 
   REAL teta0,ttp,delt_y,delt_z,eps ! Constantes pour profil de T
@@ -282,21 +282,19 @@
            ! Earth: first two tracers will be water
 
-           do i=1,nqtot
-              if (i == 1) q(ijb_u:ije_u,:,i)=1.e-10
-              if (i == 2) q(ijb_u:ije_u,:,i)=1.e-15
-              if (i.gt.2) q(ijb_u:ije_u,:,i)=0.
+           do iq=1,nqtot
+              q(ijb_u:ije_u,:,iq)=0.
+              if (tracers(iq)%name == 'H2Ov') q(ijb_u:ije_u,:,iq)=1.e-10
+              if (tracers(iq)%name == 'H2Ol') q(ijb_u:ije_u,:,iq)=1.e-15
 
               ! CRisi: init des isotopes
               ! distill de Rayleigh très simplifiée
-              if (ok_isotopes) then
-                if ((iso_num(i).gt.0).and.(zone_num(i).eq.0)) then          
-                   q(ijb_u:ije_u,:,i)=q(ijb_u:ije_u,:,iqpere(i))       &
-      &                  *tnat(iso_num(i))                             &
-      &                  *(q(ijb_u:ije_u,:,iqpere(i))/30.e-3)                              &
-     &                   **(alpha_ideal(iso_num(i))-1)
-                endif                
-                if ((iso_num(i).gt.0).and.(zone_num(i).eq.1)) then
-                  q(ijb_u:ije_u,:,i)=q(ijb_u:ije_u,:,iqiso(iso_indnum(i),phase_num(i)))
-                endif
+              iName = tracers(iq)%iso_iName
+              iZone = tracers(iq)%iso_iZone
+              iPhase= tracers(iq)%iso_iPhase
+              iqParent = tracers(iq)%iqParent
+              if (ok_isotopes .AND. iName > 0) then
+                if (iZone == 0) q(ijb_u:ije_u,:,iq) = q(ijb_u:ije_u,:,iqParent)*tnat(iName) &
+                                                    *(q(ijb_u:ije_u,:,iqParent)/30.e-3)**(alpha_ideal(iName)-1)
+                if (iZone == 1) q(ijb_u:ije_u,:,iq) = q(ijb_u:ije_u,:,iqiso(iso_indnum(iq),iPhase))
               endif !if (ok_isotopes) then
 
Index: /LMDZ6/trunk/libf/dyn3dmem/initdynav_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/initdynav_loc.F	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/initdynav_loc.F	(revision 4050)
@@ -11,5 +11,5 @@
        use Write_field
        use misc_mod
-       USE infotrac
+!       USE infotrac
        use com_io_dyn_mod, only : histaveid,histvaveid,histuaveid,       &
      &        dynhistave_file,dynhistvave_file,dynhistuave_file
Index: /LMDZ6/trunk/libf/dyn3dmem/inithist_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/inithist_loc.F	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/inithist_loc.F	(revision 4050)
@@ -11,5 +11,4 @@
        use Write_field
        use misc_mod
-       USE infotrac
        use com_io_dyn_mod, only : histid,histvid,histuid,               &
      &                        dynhist_file,dynhistv_file,dynhistu_file
